/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.GrupoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.service.GrupoCortesiasService;
import com.rjconsultores.ventaboletos.service.TipoCortesiaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("editarTipoCortesiaController")
@Scope("prototype")
public class EditarTipoCortesiaController extends MyGenericForwardComposer {

    @Autowired
    private TipoCortesiaService tipoCortesiaService;
    @Autowired
    private GrupoCortesiasService grupoCortesiaService;
    private TipoCortesia tipoCortesia;
    private MyListbox tipoCortesiaList;
    private Textbox txtNome;
    private List<GrupoCortesia> grupoCortesiaList;
    private Combobox cmbGrupoCortesia;
    private static Logger log = Logger.getLogger(EditarTipoCortesiaDController.class);
    private Button btnApagar;
    private Button btnSalvar;

    public List<GrupoCortesia> getGrupoCortesiaList() {
        return grupoCortesiaList;
    }

    public void setGrupoCortesiaList(List<GrupoCortesia> grupoCortesiaList) {
        this.grupoCortesiaList = grupoCortesiaList;
    }

    public TipoCortesia getTipoCortesia() {
        return tipoCortesia;
    }

    public void setTipoCortesia(TipoCortesia tipoCortesia) {
        this.tipoCortesia = tipoCortesia;
    }

    public MyListbox getTipoCortesiaList() {
        return tipoCortesiaList;
    }

    public void setTipoCortesiaList(MyListbox tipoCortesiaList) {
        this.tipoCortesiaList = tipoCortesiaList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Combobox getCmbGrupoCortesia() {
        return cmbGrupoCortesia;
    }

    public void setCmbGrupoCortesia(Combobox cmbGrupoCortesia) {
        this.cmbGrupoCortesia = cmbGrupoCortesia;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        grupoCortesiaList = grupoCortesiaService.obtenerTodos();
        super.doAfterCompose(comp);

        tipoCortesia = (TipoCortesia) Executions.getCurrent().getArg().get("tipoCortesia");
        tipoCortesiaList = (MyListbox) Executions.getCurrent().getArg().get("tipoCortesiaList");

        if (tipoCortesia.getTipocortesiaId() == null) {
            btnApagar.setVisible(false);
        } else {
            if (tipoCortesia.getTipocortesiaId() <= 5) {
                btnApagar.setVisible(Boolean.FALSE);
                btnSalvar.setVisible(Boolean.FALSE);
                txtNome.setDisabled(Boolean.TRUE);
                cmbGrupoCortesia.setDisabled(Boolean.TRUE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarTipoCortesiaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        }


        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        cmbGrupoCortesia.getSelectedItem();

        try {
            if (tipoCortesia.getGrupoCortesia() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTipoCortesiaController.MSG.grupo"),
                        Labels.getLabel("editarTipoCortesiaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {

                tipoCortesia.setActivo(Boolean.TRUE);
                tipoCortesia.setFecmodif(Calendar.getInstance().getTime());
                tipoCortesia.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                List<TipoCortesia> lsTipoCortesia = tipoCortesiaService.buscar(tipoCortesia.getDesctipo());

                if (!lsTipoCortesia.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarTipoCortesiaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                } else {

                    if (tipoCortesia.getTipocortesiaId() == null) {
                        tipoCortesiaService.suscribir(tipoCortesia);
                        tipoCortesiaList.addItem(tipoCortesia);
                    } else {
                        tipoCortesiaService.actualizacion(tipoCortesia);
                        tipoCortesiaList.updateItem(tipoCortesia);
                    }

                    Messagebox.show(
                            Labels.getLabel("editarTipoCortesiaController.MSG.suscribirOK"),
                            Labels.getLabel("editarTipoCortesiaController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    closeWindow();
                }
            }
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoCortesiaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoCortesiaController.MSG.BorrarPergunta"),
                    Labels.getLabel("editarTipoCortesiaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoCortesiaService.borrar(tipoCortesia);

                Messagebox.show(
                        Labels.getLabel("editarTipoCortesiaController.MSG.BorrarOK"),
                        Labels.getLabel("editarTipoCortesiaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoCortesiaList.removeItem(tipoCortesia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
